//Boston University - Electronics Design Facility
//Monkey Timer Mk2
//http://edf.bu.edu/
//written by Chris Lawlor, January - April 2011
//Device is Atmega2560
//CPU clock is 16Mhz


#include <stdio.h>
#include <string.h>

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>


#define BU 			"Boston University"
#define EDF			"Electronics Design Facility"
#define PRODUCT		"Monkey Timer 2"
#define	WEBSITE0	"see website: http://"
#define WEBSITE1	"ohm.bu.edu/cgi-bin/"
#define WEBSITE2	"edf/MonkeyTimer2"
#define	FWV			"2"			//this is the firmware version
#define VERSION		FWV


uint8_t	getDeviceSerialNumber()
{
	DDRA = 0x00;
	uint8_t a = ~(PINA); 
	uint8_t b = 0; 
	for (uint8_t j = 0; j<8; j++)
	{
		b |= (((a&(1<<j))>>j)<<(7-j));  //BIT REVERSAL
	}
	return b;
}


#include "monkey_mk2_datatypes.h"
#include "atmega2560_serial_com.h"
#include "monkey_mk2_frontpanel_buttons.h"
#include "twi_atmega2560.h"
#include "monkey_mk2_beam_control.h"
#include "rtc_ds1307.h"
//#include "pot_mcp4541.h"
#include "monkey_mk2_display.h"
#include "monkey_mk2_menu_framework.h"





int main()
{
	USART_setup();
	//USART_SendLineFeed(0);
	//SendIdentity();

	twi_master_setup();
	rtc_init();
	frontpanel_buttons_init();
	sei();
	display_init();
	render_menus();

	//push_menu(MAIN_MENU);
	//display_msg(M1, M2, M3, NULL);
	//testmacros();
	//testbuttons();
	//test_menu_stack();

	run_menu_button_handler();
	//terminal_mode();
}
